PlayerTakeEvent = {};
PlayerTakeEvent_mt = Class(PlayerTakeEvent, Event);
InitEventClass(PlayerTakeEvent, "PlayerTakeEvent");

function PlayerTakeEvent:emptyNew()
    local self = Event:new(PlayerTakeEvent_mt);
    self.className = "PlayerTakeEvent";
    return self;
end;

function PlayerTakeEvent:new(vehicle, player, take)
    local self = PlayerTakeEvent:emptyNew();
	self.vehicle = vehicle;
	self.player = player;
	self.take = take;
    return self;
end;

function PlayerTakeEvent:writeStream(streamId, connection)
	streamWriteInt32(streamId, networkGetObjectId(self.vehicle));
	streamWriteInt32(streamId, networkGetObjectId(self.player));
	streamWriteBool(streamId, self.take);
end;

function PlayerTakeEvent:readStream(streamId, connection)
	self.vehicle = networkGetObject(streamReadInt32(streamId));
	self.player = networkGetObject(streamReadInt32(streamId));
	self.take = streamReadBool(streamId);
	self:run(connection);
end;

function PlayerTakeEvent:run(connection)
	if self.take then
		self.vehicle:prendreobjet(self.player, true);
	else
		self.vehicle:lacherobjet(self.player, true);
	end;
	if not connection:getIsServer() then
		g_server:broadcastEvent(PlayerTakeEvent:new(self.vehicle, self.player, self.take), nil, connection, self.vehicle);
	end;
end;

function PlayerTakeEvent.sendEvent(vehicle, player, take, noEventSend)
	if not noEventSend then
		if g_server ~= nil then
			g_server:broadcastEvent(PlayerTakeEvent:new(vehicle, player, take), nil, nil, vehicle);
		else
			g_client:getServerConnection():sendEvent(PlayerTakeEvent:new(vehicle, player, take));
		end;
	end;
end;