-- panneau

-- by Fredzaza

panneau = {};

function panneau.prerequisitesPresent(specializations)
    return true;
end;

function panneau:load(xmlFile)
		self.racine = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.positionplayer#index"));
		self.racine2 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.objet#index"));
		self.racine3 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.positionpanneau#index"));
		self.range = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.range#index"));
		self.getPlayerInRange = panneau.getPlayerInRange;
		self.controllingPlayer = nil;
		self.prendreobjet = SpecializationUtil.callSpecializationsFunction("prendreobjet");
		self.lacherobjet = SpecializationUtil.callSpecializationsFunction("lacherobjet");
		self.carryPos = {0,2,-2}
		self.collisionMask = getCollisionMask(self.racine2);
		self.centerOfMass = {Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.col#centerOfMass"))}
		setCenterOfMass(self.racine2, unpack(self.centerOfMass));	
		self.objetselect = false;
		self.idselection = 0	
		self.distanceobjet = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.distanceobjet"), 2);
		self.logohand = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.logohand#index"));
		setVisibility(self.logohand, false)
end;

function panneau:delete()
end;

function panneau:readStream(streamId, connection)
end;

function panneau:writeStream(streamId, connection)
end;

function panneau:mouseEvent(posX, posY, isDown, isUp, button)
end;

function panneau:keyEvent(unicode, sym, modifier, isDown)
end;

function panneau:update(dt)

if self.controllingPlayer == nil then
	setTranslation(self.racine, 0,5000,0);
	if self.logohand ~= nil then
		if self.isPlayerInRange then
			setVisibility(self.logohand, true)
		else
			setVisibility(self.logohand, false)
		end;
	end;
else
	setVisibility(self.logohand, false)
end;

	if self.controllingPlayer == g_currentMission.player or (self.controllingPlayer == nil and self.isPlayerInRange) then
		if InputBinding.hasEvent(InputBinding.IMPLEMENT_EXTRA4) then
			if g_currentMission.player.objetenmain == nil then
				if self.controllingPlayer == g_currentMission.player then
				else
					self:prendreobjet(g_currentMission.player);
				end;
			else
				if self.controllingPlayer == g_currentMission.player then
					self:lacherobjet(g_currentMission.player);
					setTranslation(self.racine, 0,5000,0);
				end;
			end;
		end;		
		if self.controllingPlayer ~= nil and self.controllingPlayer == g_currentMission.player then
			local x,y,z = getWorldTranslation(self.controllingPlayer.cameraId);
			setTranslation(self.racine, x,y,z);
			local x,y,z = getWorldRotation(self.controllingPlayer.cameraId);
			setRotation(self.racine, x,y,z);
			local x,y,z = getWorldTranslation(self.racine3);
			setTranslation(self.racine2, x,y,z);
			local x,y,z = getWorldRotation(self.racine3);
			setRotation(self.racine2, x,y,z);			
			g_currentMission:addHelpButtonText(string.format(g_i18n:getText("Lacher_objet"), self.typeDesc), InputBinding.IMPLEMENT_EXTRA4);
		elseif self.controllingPlayer == nil and self.isPlayerInRange then
			g_currentMission:addHelpButtonText(string.format(g_i18n:getText("Prendre_objet"), self.typeDesc), InputBinding.IMPLEMENT_EXTRA4);	
		end;
	else
		if self.controllingPlayer ~= nil then	
			local x,y,z = getWorldTranslation(self.controllingPlayer.cameraId);
			setTranslation(self.racine, x,y,z);
			local x,y,z = getWorldRotation(self.controllingPlayer.cameraId);
			setRotation(self.racine, x,y,z);
			local x,y,z = getWorldTranslation(self.racine3);
			setTranslation(self.racine2, x,y,z);
			local x,y,z = getWorldRotation(self.racine3);
			setRotation(self.racine2, x,y,z);			
		end;
	end;
end;

function panneau:updateTick(dt)
	self.isPlayerInRange = panneau.getPlayerInRange(self, g_currentMission.player);	
end;

function panneau:getPlayerInRange(player)
	local isPlayerInRange = false; 
		if player ~= nil then
			local px, py, pz = getWorldTranslation(self.range);
			local vx, vy, vz = getWorldTranslation(player.rootNode);
			local distance = Utils.vector2Length(px-vx, pz-vz);
			local nearestDistance = self.distanceobjet;
			if distance < nearestDistance then						
				isPlayerInRange = true;
			end;
		end;
	return isPlayerInRange;
end;

function panneau:prendreobjet(player, noEventSend)
	self.controllingPlayer = player;
	if player ~= nil and player.objetenmain == nil then
		setRigidBodyType(self.rootNode, "Kinematic");
		setCollisionMask(self.rootNode, 0);
		player.objetenmain = self;
	end;
	if not noEventSend then
		PlayerTakeEvent.sendEvent(self, player, true, noEventSend);
	end;
end;

function panneau:lacherobjet(player, noEventSend)
	if player ~= nil and player.objetenmain == self then
		self.controllingPlayer = nil	
		player.objetenmain = nil;
		setRigidBodyType(self.rootNode, "Dynamic");
		setCollisionMask(self.rootNode, self.collisionMask);
		setCenterOfMass(self.rootNode, unpack(self.centerOfMass));
	end;	
	if not noEventSend then
		PlayerTakeEvent.sendEvent(self, player, false, noEventSend);	
	end;	
end;

function panneau:draw()
end;

function panneau:onAttach(attacherVehicle)
end;

function panneau:onDetach()
end;